#include <algorithm>
#include <vector>
#include <cstdio>
#include <set>

struct t_edge {
	inline t_edge(long _a, long _b , long _w): a(_a), b(_b), w(_w) {}
	inline t_edge() {}
	long a, b, w;
};

int main(int argc, char *argv[]) {
	//...
	long num_vert = atol(argv[1]), num_part = atoi(argv[2]), max_dist = atol(argv[3]);
	long rnd = atoi(argv[4]); srand(rnd);
	//...
	long id0 = num_vert - 1, id1 = 0, id2 = 1 + rand() % (num_vert - 1);
	//...
	std::vector<std::pair<long, long> > VERT(num_part); std::vector<t_edge> EDGE;
	long num = (num_vert - 2) / num_part;
	for (long i2, i1 = 1, m, n = 0, t = 0; t < num_part; i1 = i2, ++ t) {
		if (t == num_part - 1) m = num_vert - 2 - n; else m = num;
		if (!rnd && !(t % 3)) m = 1;
		i2 = i1 + m; VERT[t] = std::make_pair(i1, i2); n += m;
	}
	//...
	for (long t = 1; t < num_part; ++ t) {
		long i2 = VERT[t - 1].second, i1 = VERT[t - 1].first;
		long j2 = VERT[t].second, j1 = VERT[t].first;
		long w = rand() % max_dist;
		for (long i = i1; i < i2; ++ i)
		for (long j = j1; j < j2; ++ j) EDGE.push_back(t_edge(i, j, w));
	}
	//...
	long i2 = VERT.back().second, i1 = VERT.back().first;
	long w = rand() % max_dist;
	for (long i = i1; i < i2; ++ i) EDGE.push_back(t_edge(id0, i, w));
	i2 = VERT[0].second, i1 = VERT[0].first;
	w = rand() % max_dist;
	for (long i = i1; i < i2; ++ i) EDGE.push_back(t_edge(id1, i, w));
	//...
	std::vector<long> TEMP(num_vert);
	for (long i = 0; i < num_vert; ++ i) TEMP[i] = i;
	long num_edge = EDGE.size();
	std::random_shuffle(TEMP.begin(), TEMP.end());
	std::random_shuffle(EDGE.begin(), EDGE.end());
	//...
	FILE *fid = fopen("input.txt", "wt");
	fprintf(fid, "%li %li\n", num_vert, num_edge);
	fprintf(fid, "\n");
	for (long i = 0; i < num_edge; ++ i) {
		t_edge ed = EDGE[i];
		fprintf(fid, "%li ", TEMP[ed.a]);
		fprintf(fid, "%li ", TEMP[ed.b]);
		fprintf(fid, "%li\n", ed.w);
	}
	fprintf(fid, "\n");
	fprintf(fid, "%li\n", TEMP[id0]);
	fprintf(fid, "%li\n", TEMP[id1]);
	fprintf(fid, "%li", TEMP[id2]);
	fclose(fid);
	//...
	return 0;
}
