#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int INF = (int)1.01e9;
const int K = 10;
const int N = 1 << K;

int n, m;
vector<pair<int, int> > e[N];
int p[N][K], h[N];

int lca(int u, int v) {
    if (h[u] < h[v]) swap(u, v);
    for (int i = 0; i < K; i++) if ((h[u] - h[v]) & (1 << i)) u = p[u][i];
    if (u == v) return u;
    for (int i = K - 1; i >= 0; i--) {
        if (p[u][i] != p[v][i]) {
            u = p[u][i];
            v = p[v][i];
        }
    }
    return p[u][0];
}

#define TASK "E"
int main() {
#ifdef HOME
    assert(freopen(TASK".in", "r", stdin));
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    while (scanf("%d%d", &n, &m) == 2) {
        for (int i = 0; i < m; i++) {
            int u, v, w;
            scanf("%d%d%d", &u, &v, &w);
            e[u].push_back({v, w});
            e[v].push_back({u, w});
        }
        int f, p1, p2;
        scanf("%d%d%d", &f, &p1, &p2);

        auto dijkstra = [&](int start) {
            vector<int> d(n, INF);
            set<pair<int, int> > st;
            d[start] = 0;
            st.insert({d[start], start});
            while (!st.empty()) {
                int v = st.begin()->second;
                st.erase(st.begin());
                for (auto o : e[v]) {
                    int to = o.first, nd = d[v] + o.second;
                    if (d[to] > nd) {
                        st.erase({d[to], to});
                        d[to] = nd;
                        st.insert({d[to], to});
                    }
                }
            }
            return d;
        };
        auto d1 = dijkstra(p1);

        vector<int> vct(n);
        iota(vct.begin(), vct.end(), 0);
        sort(vct.begin(), vct.end(), [&](int v1, int v2) {
            return d1[v1] < d1[v2];
        });
        for (int v : vct) {
            if (v == p1) {
                memset(p[v], 0, sizeof(p[v]));
                h[v] = 0;
            } else {
                int cur = -1;
                for (auto o : e[v]) {
                    int to = o.first;
                    if (d1[to] + o.second == d1[v]) {
                        if (cur == -1) cur = to;
                        else cur = lca(cur, to);
                    }
                }
                p[v][0] = cur;
                for (int i = 1; i < K; i++) p[v][i] = p[p[v][i - 1]][i - 1];
                h[v] = h[cur] + 1;
            }
        }
        auto d2 = dijkstra(p2);
        int z = f;
        vector<int> ans;
        while (z != p1) {
            if (d2[z] <= d1[z]) ans.push_back(z);
            z = p[z][0];
        }
        sort(ans.begin(), ans.end());
        printf("%d\n", (int)ans.size());
        for (int i = 0; i < (int)ans.size(); i++) printf("%d ", ans[i]);
    }

    return 0;
}
